# equadrat Framework Test

The idea of the equadrat Framework is to provide APIs to build applications with an architecture of highly decoupled components. Every single component, aspect or pattern is represented by interfaces. The framework provides a standard implementation for these but each type can be replaced by a custom implementation.

The framework is not about reimplementing components, but making them available using common interfaces.

## Status

[![NuGet Version](https://img.shields.io/nuget/v/equadrat.Framework.Test.Interfaces?style=flat-square&logo=nuget&label=NuGet&labelColor=darkgreen&color=blue)](https://www.nuget.org/profiles/equadrat)\
[![Azure DevOps coverage](https://img.shields.io/azure-devops/coverage/equadrat-oss/Framework/4?label=Coverage&logo=csharp&style=flat-square&labelColor=darkgreen&color=blue)](https://dev.azure.com/equadrat-oss/Framework/_build?definitionId=4)\
[![Azure DevOps tests](https://img.shields.io/azure-devops/tests/equadrat-oss/Framework/4?label=Unit%20Tests&logo=visualstudio&style=flat-square&labelColor=darkgreen&color=blue)](https://dev.azure.com/equadrat-oss/Framework/_build?definitionId=4)

## Getting started

You can use most of the components by simply instantiating them. This is maybe the easiest way to evaluate the framework.

If you're using an IOC/DI container such as [Microsoft Extensions DependencyInjection](https://www.nuget.org/packages/Microsoft.Extensions.DependencyInjection) or if you want to use the built-in IOC framework, you can use the bootstrapper and bootstrapper modules to register the framework to the IOC.

## Usage

Have a look at the example applications on my [website](https://www.equadrat.net/) and in the [wiki](https://dev.azure.com/equadrat-oss/Framework/_wiki/wikis).

## Interesting components

This is a list of some (not all) components of the framework which might be interesting for you.

### Unit tests
- MSTestTemplate
- MSTestExtDITemplate (for Microsoft.Extensions.DependencyInjection)

## Compatibility

The plan is to keep the equadrat Framework compatible to these .net versions as long as possible.

| .net version | min   | max     |
|--------------|-------|---------|
| Core         | 3.1   | ≥ 8.x   |
| Standard     | 2.0   | ≥ 2.1   |
| Framework    | 4.6.2 | ≥ 4.8.x |

## Version scheme and breaking changes

| Version change | Scope                        |
|----------------|------------------------------|
| Major          | Overhaul of the project      |
| Minor          | Some types have changed      |
| Revision       | Fully backward compatible    |
| Build          | Set in preview versions only |

## Additional documentation

You can find some guides regarding specific features on my website: [www.equadrat.net](https://www.equadrat.net/)

## Feedback

You can contact me on my website: [www.equadrat.net](https://www.equadrat.net/en/contact/)

# License

Please respect the license and check **equadrat.Framework.Test.License.md** before using the package.
